\ir utils/small_world_array.sql

-- Before the HNSW index is created, the parameter lantern_hnsw.init_k should not be available
\set ON_ERROR_STOP off
SHOW lantern_hnsw.init_k;
\set ON_ERROR_STOP on

-- Create an index and verify that it was created
CREATE INDEX ON small_world USING lantern_hnsw (v) WITH (dim=3);
SELECT * FROM ldb_get_indexes('small_world');

-- Verify that lantern_hnsw.init_k exists after index creation
SHOW lantern_hnsw.init_k;

-- Modify lantern_hnsw.init_k and verify that it was modified
SET lantern_hnsw.init_k = 45;
SHOW lantern_hnsw.init_k;

-- Reset all parameters and verify that lantern_hnsw.init_k was reset
RESET ALL;
SHOW lantern_hnsw.init_k;

-- Validate the index data structures
SELECT _lantern_internal.validate_index('small_world_v_idx', false);
